#!/usr/bin/python3

from tkinter import *
from tkinter.ttk import *

import os.path
from os.path import *

import json


class Personne():                                 
  
    def __init__(self,nom,prenom,metier,age):                    
        self.nom = nom                                                  
        self.prenom = prenom                                           
        self.metier = metier
        self.age = age
        
    def resume(self):                                                                        
        return self.prenom+" "+self.nom
        
    def presentation(self):                                                                       
        return "Bonjour, je m'appelle "+self.prenom+" "+self.nom+", j'ai "+str(self.age)+ " ans et je suis "+self.metier
      
      


# fonction de sérialisation d'un objet, pour son écriture sur le disque au format json
def serialiseur(obj):                  
    return {"__class__":"Personne",
        "nom":obj.nom,
        "prenom":obj.prenom,
        "metier":obj.metier,
        "age":obj.age}

# fonction de désérialisation d'un objet, pour sa lecture sur le disque au format json
def deserialiseur(objet):                   
    p = Personne(objet["nom"], objet["prenom"], objet["metier"], objet["age"])
    return p
  
        
 
  
if os.path.isfile("personnes.json"):                               
    fichier = open("personnes.json","r")                               
    liste = json.load(fichier, object_hook = deserialiseur)
    fichier.close()
else:
    liste = []
    
lbox = [e.resume() for e in liste]                                   # creation d'une liste a partir de la précédente

fenetre = Tk()                                                       # creation de la fenetre principale



def action():                                                        # fonction qui va être appelée quand on appuie sur le bouton Presentation
    ind = combo.current()
    labelPres["text"] = liste[ind].presentation()
    
    
def suppression():                                                   # fonction qui va être appelée quand on appuie sur le bouton Supprimer
    ind = combo.current()
    del liste[ind]
    del lbox[ind]
    combo.configure(values = lbox)                                   # a verifier
    
    fichier = open("personnes.json","w")                             # ecriture sur le disque
    json.dump(liste, fichier, default = serialiseur, indent = 2)
    fichier.close()
    
    
def ajoutDialog():                                                         # fonction qui va être appelée quand on appuie sur le bouton Ajouter
    global dialog                                                          # pour que la variable puisse etre appelée en dehors de cette fonction
    dialog = Toplevel(fenetre)
    
    labelNom = Label(dialog, text = "nom : ")
    labelNom.grid(row = 0, column = 0)
    global entryNom
    entryNom = Entry(dialog)
    entryNom.grid(row = 0, column = 1)
    
    labelPrenom = Label(dialog, text = "prenom : ")
    labelPrenom.grid(row = 1, column = 0)
    global entryPrenom
    entryPrenom = Entry(dialog)
    entryPrenom.grid(row = 1, column = 1)
    
    labelMetier = Label(dialog, text = "metier : ")
    labelMetier.grid(row = 2, column = 0)
    global entryMetier
    entryMetier = Entry(dialog)
    entryMetier.grid(row = 2, column = 1)
    
    labelAge = Label(dialog, text = "age : ")
    labelAge.grid(row = 3, column = 0)
    global entryAge
    entryAge = Entry(dialog)
    entryAge.grid(row = 3, column = 1)

    boutonOK = Button(dialog, text="Valider", command = ajout)        
    boutonOK.grid(row = 4)
    
    
def ajout():                                                         # fonction qui va être appelée quand on appuie sur le bouton Valider du dialogue d'ajout
    nom = entryNom.get()
    prenom = entryPrenom.get()
    metier = entryMetier.get()
    age = int(entryAge.get())
    p = Personne(nom, prenom, metier, age)
    liste.append(p)
    lbox.append(p.resume())
    combo.configure(values = lbox)                                 
    dialog.destroy()                                                 # destruction du dialog
    
    fichier = open("personnes.json","w")  
    json.dump(liste, fichier, default = serialiseur, indent = 2)
    fichier.close()
    
    
 
combo = Combobox(fenetre, values = lbox)                             # creation de la combobox a partir des valeurs de la liste

combo.pack()

boutonPres = Button(fenetre, text="Presentation", command = action) # creation d'un label dans la fenetre 

boutonPres.pack()

boutonSupp = Button(fenetre, text="Supprimer", command = suppression) # creation d'un label dans la fenetre 

boutonSupp.pack()

boutonAdd = Button(fenetre, text="Ajouter", command = ajoutDialog) # creation d'un label dans la fenetre 

boutonAdd.pack()

labelPres = Label(fenetre, text="")                                  # creation d'un label dans la fenetre                                               
    
labelPres.pack()                                                     # ajustement du label dans la fenetre

fenetre.mainloop()                                                   # lancement du programme                                           